/*
 * Project Blend: the Blossom of .NET Development
 * Copyright (c) 2007 Project Blend
 * 
 *  ̺귯  ƮԴϴ. Ʈ Ǿ絵ڴ  Ʈ 
 * ǥ GNU  Ϲ   㰡 2.1 Ǵ    Ƿ ؼ,  
 *  ̺귯 ϰų   ֽϴ.
 * 
 *  ̺귯 ϰ     ǰ , Ư 
 * ´ ռ γ Ǹſ        
 *   ʽϴ.  ڼ ׿ ؼ GNU  Ϲ   㰡
 * Ͻñ ٶϴ.
 * 
 * GNU  Ϲ   㰡  ̺귯 Բ ˴ϴ. ,   
 * Ǿִٸ  Ʈ  Ͻñ ٶϴ.
 * 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * Korean Translation Comes from: http://korea.gnu.org/people/chsong/copyleft/lgpl.ko.html
 * */

using System;
using System.Collections.Generic;

namespace Blend.Sortings
{
    /// <summary>
    ///   ˰ ϴ ÷Դϴ.
    /// </summary>
    /// <typeparam name="T">÷   մϴ.   ̾ մϴ.</typeparam>
    [Serializable()]
    public class InsertionSort<T> : SortBase<T>
        where T: IComparable<T>, IComparable
    {
        public InsertionSort()
            : base()
        {
        }

        public InsertionSort(IList<T> oList)
            : base(oList)
        {
        }

        public InsertionSort(params T[] oArray)
            : base(oArray)
        {
        }

        protected override void SortInternal(bool reverse)
        {
            if (this.Count < 1)
                return;

            int i, j;
            T r;

            for (i = 1; i < this.Count; i++)
            {
                for (j = i - 1, r = this[i]; j >= 0 && this.InternalComparer(this[j], r, reverse); j--)
                    this[j + 1] = this[j];

                this[j + 1] = r;
            }
        }
    }
}
