﻿using System;
using System.Runtime.InteropServices;

namespace Blend.xPlatform.Linux
{
    [Serializable]
    [StructLayout(LayoutKind.Sequential)]
    public class mallinfo : NativeStructureBase
    {
        public int arena;
        public int orblks;
        public int smblks;
        public int hblks;
        public int hblkhd;
        public int usmblks;
        public int fsmblks;
        public int uordblks;
        public int fordblks;
        public int keepcost;

        public static implicit operator mallinfo(IntPtr ptr)
        {
            return InteropServices.ProduceManagedObject<mallinfo>(ptr);
        }
    }
}
