/*
 * Project Blend: the Blossom of .NET Development
 * Copyright (c) 2007 Project Blend
 * 
 *  ̺귯  ƮԴϴ. Ʈ Ǿ絵ڴ  Ʈ 
 * ǥ GNU  Ϲ   㰡 2.1 Ǵ    Ƿ ؼ,  
 *  ̺귯 ϰų   ֽϴ.
 * 
 *  ̺귯 ϰ     ǰ , Ư 
 * ´ ռ γ Ǹſ        
 *   ʽϴ.  ڼ ׿ ؼ GNU  Ϲ   㰡
 * Ͻñ ٶϴ.
 * 
 * GNU  Ϲ   㰡  ̺귯 Բ ˴ϴ. ,   
 * Ǿִٸ  Ʈ  Ͻñ ٶϴ.
 * 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * Korean Translation Comes from: http://korea.gnu.org/people/chsong/copyleft/lgpl.ko.html
 * */

using System;
using System.Text;
using System.Reflection;
using System.Security.Permissions;
using System.Runtime.InteropServices;

namespace Blend.xPlatform.Win32
{
    partial class msvcrt
    {
        #region Architecture Specific (Documented/Official)

        // Affected P/Invokes: atan, ceil, exp, floor, log, log10, modf, pow
        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _set_SSE2_enable();

        #endregion // Architecture Specific (Documented/Official)

        #region Buffer Manipulation (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _memccpy(IntPtr dest, IntPtr src, int c, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr memchr(IntPtr buf, int c, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int memcmp(IntPtr buf1, IntPtr buf2, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr memcpy(IntPtr dest, IntPtr src, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _memicmp(IntPtr buf1, IntPtr buf2, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr memmove(IntPtr dest, IntPtr src, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr memset(IntPtr dest, int offset, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _swab(IntPtr src, IntPtr dest, int n);

        #endregion // Buffer Maniuplation (Documented/Official)

        #region Buffer Manipulation (Undocumented)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _filbuf(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _flsbuf(int fd, IntPtr stream);

        #endregion // Buffer Manipulation (Undocumented)

        #region Byte Classification (Documented/Official)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isleadbyte(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbbalnum(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbbalpha(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbbgraph(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbbkalnum(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbbkana(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbbkprint(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbbkpunct(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbblead(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbbprint(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbbpunct(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbbtrail(uint c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbslead(string str, string current);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbslead(IntPtr str, IntPtr current);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbstrail(string str, string current);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbstrail(IntPtr str, IntPtr current);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbbtype(uint c, int type);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsbtype(string mbstr, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsbtype(IntPtr mbstr, size_t count);

        #endregion // Byte Classification (Documented/Official)

        #region Character Classification (Documented/Official)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isalnum(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isalpha(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iscntrl(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isdigit(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isgraph(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int islower(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isprint(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int ispunct(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isspace(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isupper(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isxdigit(int c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswalnum(wint_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswalpha(wint_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswascii(wint_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswcntrl(wint_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswctype(wint_t c, wctype_t desc);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswdigit(wint_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswgraph(wint_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswlower(wint_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswprint(wint_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswpunct(wint_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswspace(wint_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswupper(wint_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iswxdigit(wint_t c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcalnum(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcalpha(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcdigit(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcgraph(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbchira(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbckata(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcl0(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcl1(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcl2(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbclegal(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbclower(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcprint(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcpunct(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcspace(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcsymbol(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ismbcupper(uint c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t _mbclen(string c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int mblen(string mbstr, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __isascii(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __iscsym(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __iscsymf(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _isctype(int c, int desc);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int is_wctype(wint_t c, wctype_t desc);

        #endregion // Character Classification (Documented/Official)

        #region Data Alignment (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _aligned_free(IntPtr memblock);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _aligned_malloc(size_t size, size_t alignment);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _aligned_offset_malloc(size_t size, size_t alignment, size_t offset);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _aligned_offset_realloc(IntPtr memblock, size_t size, size_t alignment, size_t offset);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _aligned_realloc(IntPtr memblock, size_t size, size_t alignment);

        #endregion // Data Alignment (Documented/Official)

        #region Data Conversion (Documented/Official)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern long _strtoi64(string nptr, IntPtr endptr, int @base);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern long _wcstoi64(string nptr, IntPtr endptr, int @base);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern ulong _strtoui64(string nptr, IntPtr endptr, int @base);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern ulong _wcstoui64(string nptr, IntPtr endptr, int @base);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern long _atoi64(string str);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern long _wtoi64(string str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _itoa(int value, StringBuilder str, int radix);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _i64toa(long value, StringBuilder str, int radix);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _ui64toa(ulong value, StringBuilder str, int radix);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _itow(int value, StringBuilder str, int radix);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _i64tow(long value, StringBuilder str, int radix);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _ui64tow(ulong value, StringBuilder str, int radix);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int atoi(string str);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wtoi(string str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int atol(string str);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wtol(string str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int strtol(string str, StringBuilder stopword, int @base);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wcstol(string str, StringBuilder stopword, int @base);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint strtoul(string str, StringBuilder stopword, int @base);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint wcstoul(string str, StringBuilder stopword, int @base);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _ltoa(int value, StringBuilder str, int radix);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _ltow(int value, StringBuilder str, int radix);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _ultoa(uint value, StringBuilder str, int radix);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _ultow(uint value, StringBuilder str, int radix);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _atodbl(_CRT_DOUBLE value, string str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _atoldbl(_LDOUBLE value, string str);

        #endregion // Data Conversion (Documented/Official)

        #region Data Conversion (Undocumented)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint __STRINGTOLD(_LDOUBLE pld, IntPtr p_end_ptr, IntPtr str, int mult12);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint __STRINGTOLD(_LDOUBLE pld, IntPtr p_end_ptr, string str, int mult12);

        #endregion // Data Conversion (Undocumented)

        #region Data Conversion: to~ Series (Documented/Official)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __toascii(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _tolower(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _toupper(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int tolower(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int toupper(int c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wchar_t towlower(wchar_t c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wchar_t towupper(wchar_t c);

        #endregion Data Conversion: to~ Series (Documented/Official)

        #region Directory Control (Documented/Official)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _chdir(string dirname);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wchdir(string dirname);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _chdrive(int drive);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _getcwd(StringBuilder buffer, int maxlen);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wgetcwd(StringBuilder buffer, int maxlen);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _getdcwd(int drive, StringBuilder buffer, int maxlen);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wgetdcwd(int drive, StringBuilder buffer, int maxlen);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _getdiskfree(uint drive, IntPtr driveinfo);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _getdrive();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _getdrives();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mkdir(string dirname);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wmkdir(string dirname);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _rmdir(string dirname);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wrmdir(string dirname);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _searchenv(string filename, string varname, StringBuilder pathname);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _wsearchenv(string filename, string varname, StringBuilder pathname);

        #endregion // Directory Control (Documented/Official)

        #region Error Handling (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void clearerr(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int feof(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int ferror(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _set_error_mode(int modeval);

        #endregion // Error Handling (Documented/Official)

        #region Error Handling (Undocumented)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _seterrormode(int modeval);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void __setusermatherr(exception_function handler);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _errno();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __doserrno();

        #endregion // Error Handling

        #region Exception Handling (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _abnormal_termination();

        #endregion // Exception Handling (Documented/Official)

        #region Exception Handling (Undocumented)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _CxxThrowException(IntPtr exceptionReason, IntPtr exceptionType);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __CppXcptFilter(uint xcptNum, IntPtr pxcptinfoptrs);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _XcptFilter(uint xcptnum, IntPtr pxcptinfoptrs);

        #endregion // Exception Handling (Undocumented)

        #region File Handling (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _chsize(int fd, long size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _filelength(int fd);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern long _filelengthi64(int fd);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _fstat(int fd, IntPtr buffer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _fstati64(int fd, IntPtr buffer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _get_osfhandle(int fd);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _isatty(int fd);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _locking(int fd, int mode, int nbytes);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _open_osfhandle(int osfhandle, int flags);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _setmode(int fd, int mode);

        #endregion // File Handling (Documented/Official)

        #region File Handling: Path or File Names (Documented/Official)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _access(string path, int mode);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _waccess(string path, int mode);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _chmod(string filename, int pmode);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wchmod(string filename, int pmode);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _fullpath(string absPath, string relPath, size_t maxLength);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wfullpath(string absPath, string relPath, size_t maxLength);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _makepath(StringBuilder path, string drive, string dir, string fname, string ext);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _wmakepath(StringBuilder path, string drive, string dir, string fname, string ext);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mktemp(string template);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wmktemp(string template);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int remove(string path);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wremove(string path);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int rename(string oldname, string newname);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wrename(string oldname, string newname);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _splitpath(string path, StringBuilder drive, StringBuilder dir, StringBuilder fname, StringBuilder ext);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _wsplitpath(string path, StringBuilder drive, StringBuilder dir, StringBuilder fname, StringBuilder ext);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _stat(string path, IntPtr buffer);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _stati64(string path, IntPtr buffer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _fstat64(int fd, IntPtr buffer);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _stat64(string path, IntPtr buffer);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wstat(string path, IntPtr buffer);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wstati64(string path, IntPtr buffer);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wstat64(string path, IntPtr buffer);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _unlink(string filename);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wunlink(string filename);

        #endregion // File Handling: Path or FIle Names (Documented/Official)

        #region Floating-Point Support (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int abs(int n);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern long _abs64(long n);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double acos(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double asin(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double atan(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double atan2(double y, double x);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double atof(string str);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _wtof(string str);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _j0(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _j1(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _jn(int n, double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _y0(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _y1(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _yn(int n, double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _cabs(_complex z);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double ceil(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _chgsign(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _clearfp();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _control87(uint nev, uint mask);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _controlfp(uint nev, uint mask);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _copysign(double x, double y);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double cos(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double cosh(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern div_t div(int number, int denom);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _ecvt(double value, int count, int[] dec, int[] sign);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double exp(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double fabs(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _fcvt(double value, int count, int[] dec, int[] sign);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _finite(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double floor(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double fmod(double x, double y);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _fpclass(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _fpieee_flt(uint excCode, IntPtr excInfo, IntPtr handler);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _fpreset();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double frexp(double x, ref int expptr);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _gcvt(double value, int digits, StringBuilder buffer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _hypot(double x, double y);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _isnan(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int labs(int n);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double ldexp(double x, int exp);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern ldiv_t ldiv(int number, int denom);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double log(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double log10(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _logb(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _lrotl(uint value, int shift);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _lrotr(uint value, int shift);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double modf(double x, ref double intptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _nextafter(double x, double y);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double pow(double x, double y);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int rand();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _rotl(uint value, int shift);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _rotr(uint value, int shift);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _rotl64(ulong value, int shift);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _rotr64(ulong value, int shift);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _scalb(double x, int exp);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double sin(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double sinh(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double sqrt(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void srand(uint seed);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _statusfp();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double strtod(string str, StringBuilder stopword);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double wcstod(string str, StringBuilder stopword);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double tan(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double tanh(double x);

        #endregion // Floating-Point Support (Documented/Official)

        #region Floating-Point Support (Undocumented)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _adj_fdiv_m16i(short arg);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _adj_fdiv_m32(uint arg);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _adj_fdiv_m32i(int arg);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _adj_fdiv_m64(long arg);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _adj_fdiv_r();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _adj_fdivr_m16i(short arg);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _adj_fdivr_m32(uint arg);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _adj_fdivr_m32i(int arg);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _adj_fdivr_m64(long arg);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIsin(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIsinh(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIcos(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIcosh(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CItan(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CItanh(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIasin(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIacos(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIatan(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIatan2(double y, double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIexp(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIlog(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIlog10(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIpow(double x, double y);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIsqrt(double x);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double _CIfmod(double x, double y);

        [Obsolete(" Լ  C  Լ ƴ x86 Assembly Code  Դϴ.", false)]
        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _ftol();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _mbbtombc(uint c);

        #endregion Floating-Point Support (Undocumented)

        #region Global Variable Access (Undocumented)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__pgmptr();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__wpgmptr();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__iob();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__osver();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__winver();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__amblksiz();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__winmajor();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__winminor();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p___argc();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p___argv();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p___wargv();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__environ();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__wenviron();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p___mb_cur_max();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__fmode();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p___initenv();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p___winitenv();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__acmdln();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__wcmdln();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__commode();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__dstbias();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__fileinfo();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__mbcasemap();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__mbctype();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__pctype();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__pwctype();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__timezone();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__tzname();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __p__daylight();

        #endregion // Global Variable Access (Undocumented)

        #region Input and Output: Stream I/O (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fclose(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _fcloseall();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _fdopen(int fd, string mode);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wfdopen(int fd, string mode);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fflush(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fgetc(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t fgetwc(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _fgetchar();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t _fgetwchar();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fgetpos(IntPtr stream, ref fpos_t pos);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr fgets(StringBuilder str, int n, IntPtr stream);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr fgetws(StringBuilder str, int n, IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _fileno(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _flushall();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr fopen(string filename, string mode);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wfopen(string filename, string mode);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fprintf(IntPtr stream, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fprintf(IntPtr stream, string format);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fwprintf(IntPtr stream, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fwprintf(IntPtr stream, string format);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fputc(int c, IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t fputwc(wchar_t c, IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _fputchar(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _fputwchar(wchar_t c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fputs(string str, IntPtr stream);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fputws(string str, IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t fread(IntPtr buffer, size_t size, size_t count, IntPtr stream);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr freopen(string path, string mode, IntPtr stream);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wfreopen(string path, string mode, IntPtr stream);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fscanf(IntPtr stream, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fwscanf(IntPtr stream, string format, __arglist);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fseek(IntPtr stream, int offset, int origin);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fsetpos(IntPtr stream, ref fpos_t pos);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _fsopen(string filename, string mode, int shflag);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wfsopen(string filename, string mode, int shflag);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int ftell(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t fwrite(IntPtr buffer, size_t size, size_t count, IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int getc(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t getwc(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int getchar();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t getwchar();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _getmaxstdio();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr gets(StringBuilder buffer);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _getws(StringBuilder buffer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _getw(IntPtr stream);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int printf(string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int printf(string format);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wprintf(string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wprintf(string format);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int putc(int c, IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t putwc(wchar_t c, IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int putchar(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t putwchar(wchar_t c, IntPtr stream);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int puts(string str);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _putws(string str);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _putw(int binint, IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void rewind(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _rmtmp();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int scanf(string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wscanf(string format, __arglist);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void setbuf(IntPtr stream, IntPtr buffer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _setmaxstdio(int newmax);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int setvbuf(IntPtr stream, IntPtr buffer, int mode, size_t size);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _snprintf(StringBuilder buffer, size_t count, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _snprintf(StringBuilder buffer, size_t count, string format);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _snwprintf(StringBuilder buffer, size_t count, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _snwprintf(StringBuilder buffer, size_t count, string format);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _tempnam(string dir, string prefix);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wtempnam(string dir, string prefix);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr tmpfile();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr tmpnam(StringBuilder str);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wtmpnam(StringBuilder str);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int ungetc(int c, IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t ungetwc(wint_t c, IntPtr stream);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vfprintf(IntPtr stream, string format, string argptr);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vfprintf(IntPtr stream, string format, IntPtr argptr);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vfwprintf(IntPtr stream, string format, string argptr);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vfwprintf(IntPtr stream, string format, IntPtr argptr);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vprintf(string format, string argptr);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vprintf(string format, IntPtr argptr);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vwprintf(string format, string argptr);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vwprintf(string format, IntPtr argptr);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vsprintf(StringBuilder buffer, string format, string argptr);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vsprintf(StringBuilder buffer, string format, IntPtr argptr);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vswprintf(StringBuilder buffer, string format, string argptr);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int vswprintf(StringBuilder buffer, string format, IntPtr argptr);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _vsnprintf(StringBuilder buffer, size_t count, string format, string argptr);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _vsnprintf(StringBuilder buffer, size_t count, string format, IntPtr argptr);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _vsnwprintf(StringBuilder buffer, size_t count, string format, string argptr);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _vsnwprintf(StringBuilder buffer, size_t count, string format, IntPtr argptr);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _vscprintf(string format, string ap);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _vscprintf(string format, IntPtr ap);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _vscwprintf(string format, string ap);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _vscwprintf(string format, IntPtr ap);

        #endregion // Input and Output: Stream I/O (Documented/Official)

        #region Input and Output: Low-Level I/O (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _close(int fd);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _commit(int fd);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _creat(string filename, int pmode);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wcreat(string filename, int pmode);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _dup(int fd);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _dup2(int fd1, int fd2);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _eof(int fd);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _lseek(int fd, int offset, int origin);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern long _lseeki64(int fd, long offset, int origin);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _open(string filename, int oflag, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wopen(string filename, int oflag, __arglist);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _read(int fd, IntPtr buffer, uint count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _sopen(string filename, int oflag, int shflag, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wsopen(string filename, int oflag, int shflag, __arglist);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _tell(int fd);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern long _telli64(int fd);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _umask(int pmode);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _write(int fd, IntPtr buffer, uint count);

        #endregion // Input and Output: Low-Level I/O (Documented/Official)

        #region Input and Output: Console and Port I/O (Documented/Official)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _cgets(string buffer);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _cgetws(string buffer);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _cprintf(string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _cprintf(string format);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _cwprintf(string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _cwprintf(string format);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _cputs(string str);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _cputws(string str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _cscanf(string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _cwscanf(string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _getch();

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t _getwch();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _getche();

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t _getwche();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _inp(ushort port);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _inpd(ushort port);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern ushort _inpw(ushort port);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _kbhit();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _outp(ushort port, int databyte);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern ushort _outpd(ushort port, uint dataword);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern ushort _outpw(ushort port, ushort dataword);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _putch(int c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t _putwch(wchar_t c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _ungetch(int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern wint_t _ungetwch(wint_t c);

        #endregion // Input and Output: Console and Port I/O (Documented/Official)

        #region Input and Output (Undocumented)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _beep(uint freq, uint duration);

        #endregion // Input and Output (Undocumented)

        #region Locale (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr localeconv();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr setlocale(int category, string locale);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wsetlocale(int category, string locale);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t strxfrm(StringBuilder strDest, string strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t wcsxfrm(StringBuilder strDest, string strSource, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t wcstombs(IntPtr mbstr, IntPtr wcstr, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t mbstowcs(IntPtr wcstr, IntPtr mbstr, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wctomb(IntPtr mbchar, wchar_t wchar);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int mbtowc(ref wchar_t wchar, IntPtr mbchar, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _getmbcp();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _setmbcp(int codepage);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbccpy(IntPtr strDestination, IntPtr strSource);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _mbcjistojms(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _mbcjmstojis(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _mbctohira(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _mbctokata(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _mbctolower(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _mbctombb(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _mbctoupper(uint c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsdec(IntPtr start, IntPtr current);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsnbcat(IntPtr dest, IntPtr src, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsnbcmp(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t _mbsnbcnt(IntPtr str, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t _mbsnccnt(IntPtr str, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsnbcoll(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsnbcpy(IntPtr strDest, IntPtr strSource, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsnbicmp(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsnbicoll(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsnbset(IntPtr str, uint c, size_t count);

        #endregion // Locale (Documented/Official)

        #region Locale (Undocumented)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int ___lc_codepage_func();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int ___lc_collate_cp_func();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr ___lc_handle_func();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int ___setlc_active_func();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr ___unguarded_readlc_active_add_func();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __lconv_init();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __pctype_func();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __pwctype_func();

        #endregion // Locale (Undocumented)

        #region Memory Allocation (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr calloc(size_t num, size_t size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _expand(IntPtr memblock, size_t size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void free(IntPtr memblock);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _get_heap_handle();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t _get_sbh_threshold();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _heapadd(IntPtr memblock, size_t size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _heapchk();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _heapmin();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _heapset(uint fill);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _heapwalk(IntPtr entryinfo);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr malloc(size_t size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr malloc(uint size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t _msize(IntPtr memblock);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr realloc(IntPtr memblock, size_t newsize);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _set_sbh_threshold(size_t size);

        #endregion // Memory Allocation (Documented/Official)

        #region Memory Allocation (Undocumented)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _callnewh(size_t size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t _heapused(IntPtr pUsed, IntPtr pCommit);

        #endregion // Memory Allocation (Undocumented)

        #region Multibyte Supplement (Undocumented)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int ___mb_cur_max_func();

        #endregion // Multibyte Supplement (Undocumented)

        #region Process and Environment Control (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void abort();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _assert(int expression);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int atexit(terminate_function function);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uintptr_t _beginthread(
            _beginthread_start_routine_t start_address,
            uint stack_size, IntPtr arglist);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uintptr_t _beginthreadex(
            IntPtr security,
            uint stack_size,
            _beginthreadex_start_routine_t start_address,
            IntPtr arglist,
            uint initflag,
            ref IntPtr thrdaddr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _cexit();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _c_exit();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _cwait(IntPtr termstat, intptr_t procHandle, int action);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _endthread();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _endthreadex(uint retval);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _execl(string cmdname, string arg0, __arglist);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _resetstkoflw();

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wexecl(string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _execle(string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wexecle(string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _execlp(string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wexeclp(string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _execlpe(string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wexeclpe(string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _execv(string cmdname, string[] argv);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wexecv(string cmdname, string[] argv);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _execve(string cmdname, string[] argv, string[] envp);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wexecve(string cmdname, string[] argv, string[] envp);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _execvp(string cmdname, string[] argv);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wexecvp(string cmdname, string[] argv);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _execvpe(string cmdname, string[] argv, string[] envp);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wexecvpe(string cmdname, string[] argv, string[] envp);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _exit(int status);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void exit(int status);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr getenv(string varname);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wgetenv(string varname);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _getpid();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void longjmp(
            [MarshalAs(UnmanagedType.LPArray, ArraySubType = UnmanagedType.SysUInt, SizeConst = msvcrt._JBLEN)] uint[] env,
            int value);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern _onexit_t _onexit(_onexit_t function);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _pclose(IntPtr stream);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void perror(string @string);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _wperror(string @string);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _pipe(
            [MarshalAs(UnmanagedType.LPArray, ArraySubType = UnmanagedType.SysInt, SizeConst = 2)] int[] pfds,
            uint psize, int textmode);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _popen(string command, string mode);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wpopen(string command, string mode);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _putenv(string envstring);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wputenv(string envstring);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int raise(int sig);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _setjmp(
            [MarshalAs(UnmanagedType.LPArray, ArraySubType = UnmanagedType.SysUInt, SizeConst = msvcrt._JBLEN)] uint[] env);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern __sighandler_t signal(int sig, __sighandler_t func);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _spawnl(int mode, string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wspawnl(int mode, string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _spawnle(int mode, string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wspawnle(int mode, string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _spawnlp(int mode, string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wspawnlp(int mode, string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _spawnlpe(int mode, string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wspawnlpe(int mode, string cmdname, string arg0, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _spawnv(int mode, string cmdname, string[] args);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wspawnv(int mode, string cmdname, string[] args);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _spawnve(int mode, string cmdname, string[] args, string[] envp);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wspawnve(int mode, string cmdname, string[] args, string[] envp);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _spawnvp(int mode, string cmdname, string[] args);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wspawnvp(int mode, string cmdname, string[] args);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _spawnvpe(int mode, string cmdname, string[] args, string[] envp);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wspawnvpe(int mode, string cmdname, string[] args, string[] envp);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int system(string command);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wsystem(string command);

        #endregion // Process and Environment Control (Documented/Official)

        #region Process and Environment Control (Undocumented)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint __threadid();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint __threadhandle();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _sleep(uint duration);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern _onexit_t __dllonexit(_onexit_t func, IntPtr pbegin, IntPtr pend);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __getmainargs(IntPtr pargc, IntPtr pargv, IntPtr penvp, int dowildcard, IntPtr startinfo);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __wgetmainargs(IntPtr pargc, IntPtr pargv, IntPtr penvp, int dowildcard, IntPtr startinfo);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __fpecode();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __pxcptinfoptrs();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void __set_app_type(int at);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _amsg_exit();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _initterm(IntPtr pfbegin, IntPtr pfend);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _lock(int locknum);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _unlock(int locknum);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _purecall();

        #endregion // Process and Environment Control (Undocumented)

        #region Searching and Sorting (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr bsearch(IntPtr key, IntPtr @base, ref uint num, uint width, _compare_routine compare);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _lfind(IntPtr key, IntPtr @base, ref uint num, uint width, _compare_routine compare);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _lsearch(IntPtr key, IntPtr @base, ref uint num, uint width, _compare_routine compare);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr qsort(IntPtr @base, uint num, uint width, _compare_routine compare);

        #endregion Searching and Sorting (Documented/Official)

        #region String Manipulation (Documented/Official)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int sprintf(StringBuilder buffer, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int sprintf(StringBuilder buffer, string format);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int swprintf(StringBuilder buffer, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int swprintf(StringBuilder buffer, string format);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int sscanf(string buffer, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int sscanf(IntPtr buffer, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int swscanf(string buffer, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int swscanf(IntPtr buffer, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t _mbstrlen(string str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strcat(IntPtr strDestination, string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strcat(IntPtr strDestination, IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbscat(IntPtr strDestination, string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbscat(IntPtr strDestination, IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcscat(IntPtr strDestination, string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcscat(IntPtr strDestination, IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strchr(string str, int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strchr(StringBuilder str, int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsrchr(string str, int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsrchr(StringBuilder str, int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbschr(string str, int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbschr(StringBuilder str, int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strchr(IntPtr str, int c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcschr(string str, int c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcschr(StringBuilder str, int c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcschr(IntPtr str, int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int strcmp(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int strcmp(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbscmp(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbscmp(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wcscmp(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wcscmp(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int strcoll(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int strcoll(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbscoll(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbscoll(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wcscoll(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wcscoll(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strcpy(IntPtr strDestination, string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbscpy(IntPtr strDestination, string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcscpy(IntPtr strDestination, string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strcpy(IntPtr strDestination, IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbscpy(IntPtr strDestination, IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcscpy(IntPtr strDestination, IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int strcspn(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int strcspn(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbscspn(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbscspn(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wcscspn(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wcscspn(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strerror(int errnum);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strerror(IntPtr strErrMsg);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strerror(string strErrMsg);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wcserror(int errnum);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __wcserror(string strErrMsg);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __wcserror(IntPtr strErrMsg);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t strlen(string @string);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t strlen(IntPtr @string);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t _mbslen(string @string);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t _mbslen(IntPtr @string);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t wcslen(string @string);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t wcslen(IntPtr @string);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strncat(IntPtr strDestination, string strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strncat(IntPtr strDestination, IntPtr strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsncat(IntPtr strDestination, string strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsncat(IntPtr strDestination, IntPtr strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcsncat(IntPtr strDestination, string strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcsncat(IntPtr strDestination, IntPtr strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int strncmp(string string1, string string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int strncmp(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsncmp(string string1, string string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsncmp(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wcsncmp(string string1, string string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int wcsncmp(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strncpy(IntPtr strDestination, string strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsncpy(IntPtr strDestination, string strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcsncpy(IntPtr strDestination, string strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strncpy(IntPtr strDestination, IntPtr strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsncpy(IntPtr strDestination, IntPtr strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcsncpy(IntPtr strDestination, IntPtr strSource, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strpbrk(IntPtr strDestination, string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbspbrk(IntPtr strDestination, string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcspbrk(IntPtr strDestination, string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strpbrk(IntPtr strDestination, IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbspbrk(IntPtr strDestination, IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcspbrk(IntPtr strDestination, IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strrchr(string @string, int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strrchr(IntPtr @string, int c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcsrchr(string @string, int c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcsrchr(IntPtr @string, int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t strspn(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t strspn(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t _mbsspn(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t _mbsspn(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t wcsspn(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t wcsspn(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strstr(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strstr(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsstr(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsstr(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcsstr(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcsstr(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strtok(IntPtr strToken, string strDelimit);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbstok(IntPtr strToken, string strDelimit);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr wcstok(IntPtr strToken, string strDelimit);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _strcmpi(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _strcmpi(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _stricmp(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _stricmp(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsicmp(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsicmp(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wcsicmp(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wcsicmp(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _stricoll(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _stricoll(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsicoll(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsicoll(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wcsicoll(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wcsicoll(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _snscanf(string buffer, size_t length, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _snscanf(IntPtr buffer, size_t length, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _snwscanf(string buffer, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _snwscanf(IntPtr buffer, string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsinc(string current, _locale_t locale);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsinc(IntPtr current, _locale_t locale);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strupr(IntPtr str);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wcsupr(IntPtr str);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsupr(IntPtr str);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strlwr(IntPtr str);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wcslwr(IntPtr str);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbslwr(IntPtr str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strdup(string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strdup(IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsdup(string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsdup(IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wcsdup(string strSource);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wcsdup(IntPtr strSource);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _strncoll(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _strncoll(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsncoll(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsncoll(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wcsncoll(string string1, string string2);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wcsncoll(IntPtr string1, IntPtr string2);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _strnicmp(string string1, string string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _strnicmp(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsnicmp(string string1, string string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsnicmp(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wcsnicmp(string string1, string string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wcsnicmp(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _strnicoll(string string1, string string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _strnicoll(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsnicoll(string string1, string string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _mbsnicoll(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wcsnicoll(string string1, string string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wcsnicoll(IntPtr string1, IntPtr string2, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strrev(string str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strrev(IntPtr str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsrev(string str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsrev(IntPtr str);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wcsrev(string str);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wcsrev(IntPtr str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _mbsnextc(string str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _mbsnextc(IntPtr str);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsninc(string str, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsninc(IntPtr str, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strnset(IntPtr str, int c, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsnset(IntPtr str, uint c, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wcsnset(IntPtr str, wchar_t c, size_t count);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strset(IntPtr str, int c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsset(IntPtr str, uint c);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wcsset(IntPtr str, wchar_t c);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsspnp(string str, string charset);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _mbsspnp(IntPtr str, IntPtr charset);

        #endregion // String Manipulation (Documented/Official)

        #region String Manipulation (Undocumented)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtCompareStringA(
            _locale_t plocinfo, LC_ID Locale, uint dwCmpFlags,
            IntPtr lpString1, int cchCount1,
            IntPtr lpString2, int cchCount2,
            int code_page);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtCompareStringA(
            _locale_t plocinfo, LC_ID Locale, uint dwCmpFlags,
            string lpString1, int cchCount1,
            string lpString2, int cchCount2,
            int code_page);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtCompareStringW(
            _locale_t plocinfo, LCID Locale, uint dwCmpFlags,
            IntPtr lpString1, int cchCount1,
            IntPtr lpString2, int cchCount2,
            int code_page);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtCompareStringW(
            _locale_t plocinfo, LCID Locale, uint dwCmpFlags,
            string lpString1, int cchCount1,
            string lpString2, int cchCount2,
            int code_page);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtGetLocaleInfoW(
            _locale_t plocinfo, LCID Locale, uint LCType,
            IntPtr lpLCData, int cchData, int code_page);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtGetLocaleInfoW(
            _locale_t plocinfo, LCID Locale, uint LCType,
            string lpLCData, int cchData, int code_page);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtGetStringTypeW(
            _locale_t plocinfo, uint dwInfoType, IntPtr lpSrcStr,
            int cchSrc, IntPtr lpCharType, int code_page, int lcid);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtGetStringTypeW(
            _locale_t plocinfo, uint dwInfoType, string lpSrcStr,
            int cchSrc, IntPtr lpCharType, int code_page, int lcid);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtLCMapStringA(
            _locale_t plocinfo, LCID Locale, uint dwMapFlags,
            IntPtr lpSrcStr, int cchSrc,
            IntPtr lpDestStr, int cchDest,
            int code_page, int bError);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtLCMapStringA(
            _locale_t plocinfo, LCID Locale, uint dwMapFlags,
            string lpSrcStr, int cchSrc,
            IntPtr lpDestStr, int cchDest,
            int code_page, int bError);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtLCMapStringW(
            _locale_t plocinfo, LCID Locale, uint dwMapFlags,
            IntPtr lpSrcStr, int cchSrc,
            IntPtr lpDestStr, int cchDest,
            int code_page, int bError);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int __crtLCMapStringW(
            _locale_t plocinfo, LCID Locale, uint dwMapFlags,
            string lpSrcStr, int cchSrc,
            IntPtr lpDestStr, int cchDest,
            int code_page, int bError);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _scprintf(string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _scprintf(string format);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _scwprintf(string format, __arglist);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _scwprintf(string format);

        #endregion // String Manipulation (Undocumented)

        #region System Calls (Documented/Official)

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _findclose(intptr_t handle);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _findfirst(string filespec, IntPtr fileinfo);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern intptr_t _wfindfirst(string filespec, IntPtr fileinfo);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _findnext(intptr_t handle, IntPtr fileinfo);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wfindnext(intptr_t handle, IntPtr fileinfo);

        #endregion // System Calls (Documented/Official)

        #region Time Management (Documented/Official)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr asctime(tm timeptr);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wasctime(tm timeptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern clock_t clock();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr ctime(time_t timer);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _ctime64(__time64_t timer);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wctime(time_t timer);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wctime64(__time64_t timer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern double difftime(time_t timer1, time_t timer0);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _ftime(IntPtr timeptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _ftime64(IntPtr timeptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _futime(int fd, IntPtr filetime);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _futime64(int fd, IntPtr filetime);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr gmtime(time_t timer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _gmtime64(__time64_t timer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr localtime(ref time_t timer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern time_t mktime(IntPtr timeptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern __time64_t _mktime64(IntPtr timeptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern time_t _mkgmtime(IntPtr timeptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern __time64_t _mkgmtime64(IntPtr timeptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strdate(IntPtr datestr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wstrdate(IntPtr datestr);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t strftime(IntPtr strDest, size_t maxSize, IntPtr format, IntPtr timeptr);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t strftime(StringBuilder strDest, size_t maxSize, string format, tm timeptr);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t wcsftime(IntPtr strDest, size_t maxSize, IntPtr format, IntPtr timeptr);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern size_t wcsftime(StringBuilder strDest, size_t maxSize, string format, tm timeptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _strtime(IntPtr timestr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _wstrtime(IntPtr timestr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern time_t time(ref time_t timer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern __time64_t _time64(ref __time64_t timer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _tzset();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _utime(string filename, IntPtr times);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _utime64(string filename, IntPtr times);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wutime(string filename, IntPtr times);

        [DllImport(ModuleName, CharSet = CharSet.Unicode, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _wutime64(string filename, IntPtr times);

        #endregion // Time Management (Documented/Official)

        #region Time Management (Undocumented)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _Getdays();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _Getmonths();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _Gettnames();

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _Strftime(StringBuilder @out, uint len, string format, IntPtr tm, IntPtr foo);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _getsystime(IntPtr ptm);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern uint _setsystime(IntPtr ptm, uint uMilliseconds);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _localtime64(IntPtr ptime);

        #endregion // Time Management (Undocumented)

        #region Extensions (Undocumented)

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _getdllprocaddr(IntPtr hMod, string szProcName, int ordinal);

        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr _loaddll(string szName);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _unloaddll(IntPtr hMod);

        #endregion // Extensions (Undocumented)

        #region Macro Compatibilities

        public static bool S_ISCHR(int m)
        {
            return (m & _S_IFMT).Equals(_S_IFCHR);
        }

        public static bool S_ISDIR(int m)
        {
            return (m & _S_IFMT).Equals(_S_IFDIR);
        }

        public static bool S_ISFIFO(int m)
        {
            return (m & _S_IFMT).Equals(_S_IFIFO);
        }

        public static bool S_ISREG(int m)
        {
            return (m & _S_IFMT).Equals(_S_IFREG);
        }

        public static int _BLOCK_TYPE(ushort block)
        {
            return (block & 0xFFFF);
        }

        public static int _BLOCK_SUBTYPE(ushort block)
        {
            return (block >> 16 & 0xFFFF);
        }

        public static int @sizeof(Type targetType)
        {
            return Marshal.SizeOf(targetType);
        }

        public static int @sizeof<T>()
        {
            return @sizeof(typeof(T));
        }

        public static IntPtr offsetof(Type targetType, string fieldName)
        {
            return Marshal.OffsetOf(targetType, fieldName);
        }

        public static IntPtr offsetof<T>(string fieldName)
        {
            return offsetof(typeof(T), fieldName);
        }

        public static T __max<T>(T left, T right)
            where T : IComparable
        {
            return (left.CompareTo(right) > 0) ? left : right;
        }

        public static int __max(int left, int right)
        {
            return __max<int>(left, right);
        }

        public static T __min<T>(T left, T right)
            where T : IComparable
        {
            return (left.CompareTo(right) < 0) ? left : right;
        }

        public static int __min(int left, int right)
        {
            return __min<int>(left, right);
        }

        public static T max<T>(T left, T right)
            where T : IComparable
        {
            return (left.CompareTo(right) > 0) ? left : right;
        }

        public static int max(int left, int right)
        {
            return max<int>(left, right);
        }

        public static T min<T>(T left, T right)
            where T : IComparable
        {
            return (left.CompareTo(right) < 0) ? left : right;
        }

        public static int min(int left, int right)
        {
            return min<int>(left, right);
        }

        public static double log2(double n)
        {
            return (n.Equals(e) ? M_LOG2E : Math.Log(n, 2.0));
        }

        #endregion // Macro Compatibilities

        #region Experimental Functions

        // ó: http://source.winehq.org/WineAPI

        [DllImport(ModuleName)]
        [Obsolete("䰡 ʿմϴ.", false)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __RTCastToVoid(IntPtr cppobj);

        // ó: http://source.winehq.org/WineAPI

        [DllImport(ModuleName)]
        [Obsolete("䰡 ʿմϴ.", false)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __RTDynamicCast(IntPtr cppobj, int reserved, IntPtr src, IntPtr dst, int do_throw);

        // ó: http://source.winehq.org/WineAPI

        [DllImport(ModuleName)]
        [Obsolete("䰡 ʿմϴ.", false)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __RTtypeid(IntPtr cppobj);

        // ó: http://source.winehq.org/WineAPI

        [Obsolete("䰡 ʿմϴ.", false)]
        [DllImport(ModuleName, CharSet = CharSet.Ansi, ExactSpelling = true)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr __unDNameEx(StringBuilder buffer, string mangled,
            int buflen, malloc_func_t memget, free_func_t memfree, IntPtr unknown, uint flags);

        // ó: http://source.winehq.org/WineAPI

        [Obsolete(" Լ  C  Լ ƴ x86 Assembly Code  Դϴ.", false)]
        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void _chkesp();

        #endregion // Experimental Functions
    }
}
