/*
 * Project Blend: the Blossom of .NET Development
 * Copyright (c) 2007 Project Blend
 * 
 *  ̺귯  ƮԴϴ. Ʈ Ǿ絵ڴ  Ʈ 
 * ǥ GNU  Ϲ   㰡 2.1 Ǵ    Ƿ ؼ,  
 *  ̺귯 ϰų   ֽϴ.
 * 
 *  ̺귯 ϰ     ǰ , Ư 
 * ´ ռ γ Ǹſ        
 *   ʽϴ.  ڼ ׿ ؼ GNU  Ϲ   㰡
 * Ͻñ ٶϴ.
 * 
 * GNU  Ϲ   㰡  ̺귯 Բ ˴ϴ. ,   
 * Ǿִٸ  Ʈ  Ͻñ ٶϴ.
 * 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * Korean Translation Comes from: http://korea.gnu.org/people/chsong/copyleft/lgpl.ko.html
 * */

using System;
using System.Collections.Generic;

namespace Blend.Sortings
{
    /// <summary>
    ///   ˰ ϴ ÷Դϴ.
    /// </summary>
    /// <typeparam name="T">÷   մϴ.   ̾ մϴ.</typeparam>
    [Serializable()]
    public class BubbleSort<T> : SortBase<T>
        where T: IComparable<T>, IComparable
    {
        public BubbleSort()
            : base()
        {
        }

        public BubbleSort(IList<T> oList)
            : base(oList)
        {
        }

        public BubbleSort(params T[] oArray)
            : base(oArray)
        {
        }

        protected override void SortInternal(bool reverse)
        {
            if (this.Count < 1)
                return;

            int i, j, flag = 1;

            for (i = 0; i < this.Count && !flag.Equals(0); i++)
            {
                for (j = flag = 0; j < this.Count - i - 1; j++)
                {
                    if (this.InternalComparer(this[j], this[j + 1], reverse))
                    {
                        flag = 1;
                        T temp = this[j];
                        this[j] = this[j + 1];
                        this[j + 1] = temp;
                    }
                }
            }
        }
    }
}
