﻿using System;
using System.Runtime.InteropServices;

namespace Blend.xPlatform.Win32
{
    [Serializable]
    public enum EVENT_TYPE : byte
    {
        NotificationEvent,
        SynchronizationEvent
    }

    [Serializable]
    public enum TIMER_TYPE : byte
    {
        NotificationTimer,
        SynchronizationTimer
    }

    [Serializable]
    public enum WAIT_TYPE : byte
    {
        WaitAll,
        WaitAny
    }

    [Serializable]
    public enum CHAR : byte { }

    [Serializable]
    public enum SHORT : short { }

    [Serializable]
    public enum LONG : int { }

    [Serializable]
    public enum WCHAR : ushort { }

    [Serializable]
    public enum UCHAR : byte { }

    [Serializable]
    public enum USHORT : ushort { }

    [Serializable]
    public enum ULONG : uint { }

    [Serializable]
    public enum SCHAR : sbyte { }

    [Serializable]
    public enum FCHAR : byte { }

    [Serializable]
    public enum FSHORT : ushort { }

    [Serializable]
    public enum FLONG : uint { }

    [Serializable]
    public enum HRESULT : int { }

    [Serializable]
    public enum CCHAR : byte { }

    [Serializable]
    public enum CSHORT : short { }

    [Serializable]
    public enum CLONG : uint { }

    [Serializable]
    public enum LCID : uint { }

    [Serializable]
    public enum LANGID : ushort { }

    [Serializable]
    public enum LOGICAL : uint { }

    [Serializable]
    public enum NTSTATUS : int { }

    [Serializable]
    public enum LONGLONG : long { }

    [Serializable]
    public enum ULONGLONG : ulong { }

    [Serializable]
    public enum USN : long { }

    [Serializable]
    public enum BOOLEAN : byte { }

    [Serializable]
    public enum BOOL : uint { }
}
